Enhance index task processing to limit re-tries.
Status: Closed Start date: 2012-08-30

Priority: Normal Due date:  

Assignee: Skye Roseboom % Done: 100%

Category: d1_indexer Estimated time: 0.00 hour

Target version: Sprint-2012.35-Block.5.2   

Milestone: CCI-1.0.4 Story Points:  

Product Version: *   

Description

Update index task processing to detect when a task has attempted sufficient retries and move the task to a failure status.

Consider how limited retries will effect processing ORE docs that are 'waiting' for data to appear.  Probaby best to limit retries and

allow auditing to handle it once a day or so.

Consider listener on objectPath to create index tasks for science metadata and resource maps?  Indicates document is present on

one CN file system - not necessarily the local.  So limited help.  Possible to listen to metacat replication complete events for local

filesystem?

Create second quartz taks in the index-processor daemon that handles failed tasks daily or so.

History

#1 - 2012-08-30 18:40 - Skye Roseboom

- Milestone changed from CCI-1.0.4 to CCI-1.0.5

#2 - 2012-08-30 19:54 - Skye Roseboom

- Milestone changed from CCI-1.0.5 to CCI-1.1

#3 - 2012-09-05 02:47 - Skye Roseboom

- Milestone changed from CCI-1.1 to CCI-1.0.4

#4 - 2012-09-05 02:59 - Skye Roseboom

Implementing a processing back off strategy for IndexTask processing.  After 2 retries or 1 failure the index task will be marked FAILED and a

'nextExecution' timestamp is set onto the task.  So no index task will be retried more than 2 times without failing.

Once in failure state, the task will not process again until the 'nextExecution' time has passed.  The back-off strategy in IndexTask will move the

execution time for first failure at 20 minutes, then 2 hours, then 8 hours, then 24 hours.  After 3 attempts at the 24hour retry level, the task it moved to

its final state - once a week retry.

#5 - 2012-09-05 03:17 - Skye Roseboom

- File redmine3162.txt added

initial update patch.

#6 - 2012-09-05 03:47 - Skye Roseboom

also need to move peggym.130.4-archived science metadata file for delete unit test.
#7 - 2012-09-05 20:14 - Skye Roseboom

- Tracker changed from Story to Task

#8 - 2012-09-05 20:16 - Skye Roseboom

- Status changed from In Progress to Testing

Moved to 1.0.0 branch for testing in RC of 1.0.4

#9 - 2012-09-12 14:30 - Skye Roseboom

- Status changed from Testing to Closed

Tested on stage environment with 1.0.4 RC.

Ran index rebuild process and index-process daemon.

Index log less chatty about tasks that cannot process yet or at all as the retry back-off strategy takes effect.  Failed index tasks are eventually (as

determined by back-off strategy) retried as part of normal index processing.

Files

redmine3162.txt 26.3 KB 2012-09-05 Skye Roseboom
